unit ADKCreate;
{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, ADKCreate1, ADKCreate2, ADKCreate3,
  ComCtrls, HandBook, HandBook2, ADKCreate4, ADKCreate5, ADKCreate6, ADKCreate7,
  ADKCreate8, ADKCreate9, ADKCreateA, ADKCreateB, ADKCreateC, Player,
  JvComponent, JvTransBtn;

type
  TCreateForm = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    lbBack: TJvTransparentButton;
    lbNext: TJvTransparentButton;
    lbCancel: TJvTransparentButton;
    Bevel1: TBevel;
    procedure lbCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbNextMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbBackMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Frame51Label2Click(Sender: TObject);
  private
    { Dclarations prives }
    bouton: TjvTransparentButton;
    Frames: array[1..$C] of TFrame;
    Frame: integer;

    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure SetFrame(value: integer);
    procedure EnableButton(Button: TjvTransparentButton);
    procedure DisableButton(Button: TjvTransparentButton);
  public
    { Dclarations publiques }
    procedure CreateParams(var Params: TCreateParams); override;
  end;

  TPersonnage = record
    Langues: TLangues;
    Armes: TWeapons;
    PointsArme: integer;
    PointCompVoleurs: integer;
    PointLangue: integer;
  //PointsVie :integer;
  end;

var
  CreateForm: TCreateForm;
  Personnage: TPersonnage;


implementation

uses ADKHelp1;

{$R *.dfm}
procedure TCreateForm.CreateParams(var Params: TCreateParams);
begin
  { We should really create a new TCustomForm-descendant, called
    TMovableBorderForm or something like that, that we'd inherit from, instead
    of placing all this nasty Windows-specific code directly in our main form.
    However, that would probably cause trouble with the form designer, and we'd
    wind up with creating everything dynamically. Visual form inheritance could
    probably help us out, but this is just a demo application, and we'd just be
    complicating matters unnecessarily. }
  inherited;
  with Params do
    Style := (Style or WS_POPUP or WS_BORDER) and not WS_DLGFRAME;
end;

procedure TCreateForm.WMNCHitTest(var Message: TWMNCHitTest);
begin
  inherited;
  //if (ScreenToClient(Mouse.CursorPos).Y < imgLogo.Top + imgLogo.Height) and
  //  (ScreenToClient(Mouse.CursorPos).X < TransButton_minimize.Left) then
    Message.Result := HTCAPTION;
end;


procedure TCreateForm.FormCreate(Sender: TObject);
begin
// Valeurs par dfaut du joueur
  FillChar(Character, SizeOf(Personnage), 0);
  Character.Alignment := NN;
  SetFrame(1);
end;

procedure TCreateForm.SetFrame(value: integer);
begin
  if Frames[value] = nil then begin
    case value of
      1: Frames[value] := TFrame1.Create(self);
      2: Frames[value] := TFrame2.Create(self);
      3: Frames[value] := TFrame3.Create(self);
      4: Frames[value] := TFrame4.Create(self);
      5: Frames[value] := TFrame5.Create(self);
      6: Frames[value] := TFrame6.Create(self);
      7: Frames[value] := TFrame7.Create(self);
      8: Frames[value] := TFrame8.Create(self);
      9: Frames[value] := TFrame9.Create(self);
      $A: Frames[value] := TFrameA.Create(self);
      $B: Frames[value] := TFrameB.Create(self);
      $C: Frames[value] := TFrameC.Create(self);
    end;
    Frames[Value].parent := self;
    Frames[Value].Align:= alClient;
  end;
  Frames[Value].show;
  if frame > 0 then Frames[Frame].Hide;
  frame := Value;
end;

procedure TCreateForm.EnableButton(Button: TjvTransparentButton);
begin
  Button.Enabled:= true;
  //Button.Font.Color := clWhite;
  //Button.OnMouseEnter := lbBackMouseEnter;
  //Button.OnMouseLeave := lbBackMouseLeave;
end;

procedure TCreateForm.DisableButton(Button: TjvTransparentButton);
begin
  Button.Enabled:= false;
  //Button.Font.Color := clGray;
  //Button.OnMouseEnter := nil;
  //Button.OnMouseLeave := nil;
end;

procedure TCreateForm.lbCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TCreateForm.lbNextMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  f: integer;
begin
  if Frame = $C then exit; // last frame
  f := Frame + 1; // next frame
  if (f = 6) and (ExceptionalStrength = False) then inc(f);
  if (f = 7) and (Character.Classes * Wizard = []) then inc(f);
  if (f = 8) and (Character.Classes * Rogue = []) then inc(f);
  SetFrame(f);
  case f of
    2: EnableButton(lbBack); // we can go back
    3: TFrame3(Frames[3]).ValiderRaces;
    4: TFrame4(Frames[4]).InfoRace;
    5: TFrame5(Frames[5]).ChoixClasse;
    6: TFrame6(Frames[6]).ForceExceptionnelle;
    7: TFrame7(Frames[7]).EcolesDeMagie;
    8: TFrame8(Frames[8]).CompetencesDeVoleur;
    9: TFrame9(Frames[9]).ChoixLangues;
    $A: TFrameA(Frames[$A]).ChoixDesArmes;
    $B: TFrameB(Frames[$B]).PointsDeVie;
    $C: begin
        TFrameC(Frames[$C]).Creation;
        DisableButton(lbNext); // can't go next
      end;
  end;
end;

procedure TCreateForm.lbBackMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  f: integer;
begin
  case Frame of
    1: exit;
    2: DisableButton(lbBack);
    $C: EnableButton(lbNext);
  end;
  f := Frame - 1;
  if (f = 8) and (Character.Classes * Rogue = []) then dec(f);
  if (f = 7) and (Character.Classes * Wizard = []) then dec(f);
  if (f = 6) and (ExceptionalStrength = False) then dec(f);
  SetFrame(f);
end;

procedure TCreateForm.Frame51Label2Click(Sender: TObject);
begin
  with TClasseForm.Create(Application) do begin
    ShowModal;
    Free;
  end;
end;

end.

