unit ADKCreate2;
{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, StdCtrls, HandBook, HandBook2, Players, Buttons;

type
  TFrame2 = class(TFrame)
    Image1: TImage;
    lbTirage: TLabel;
    lbScore: TLabel;
    Label2: TLabel;
    Relancer: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    lbReserve: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Label1: TLabel;
    Bevel2: TBevel;
    pbCaracteristiques: TPaintBox;
    procedure RelancerClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure pbCaracteristiquesPaint(Sender: TObject);
  private
    { Dclarations prives }
    reserve: integer;
    procedure DessinerDe(Canvas: TCanvas; x, y: integer; c: TAbility; d: integer);
  public
    { Dclarations publiques }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses ADKCreate, ADKHelp, Player;

{$R *.dfm}

constructor TFrame2.Create(AOwner: TComponent);
begin
  inherited;
  Parent := TWinControl(AOwner);
  Randomize;
  RelancerClick(nil);
end;

procedure TFrame2.RelancerClick(Sender: TObject);
begin
  RollDice;
  pbCaracteristiquesPaint(Self);
  Reserve := 0;
  lbReserve.caption := 'aucun point en rserve';
end;

procedure TFrame2.DessinerDe(Canvas: TCanvas; x, y: integer; c: TAbility; d: integer);
begin
  with Canvas, DiceRoll[c] do begin
    if d = less then begin
      Pen.Color := clGray;
      Brush.Color := clSilver;
    end else begin
      Pen.Color := clBlack;
      Brush.Color := clWhite
    end;
    RoundRect(x, y, x + 15, y + 15, 6, 6);
    if d = less then Brush.Color := clGray else Brush.Color := clBlack;
    if odd(dice[d]) then FillRect(Classes.Rect(x + 6, y + 6, x + 6 + 3, y + 6 + 3));
    if dice[d] > 1 then begin
      FillRect(Rect(x + 2, y + 2, x + 2 + 3, y + 2 + 3));
      FillRect(Rect(x + 10, y + 10, x + 10 + 3, y + 10 + 3));
      if dice[d] > 3 then begin
        FillRect(Rect(x + 2, y + 10, x + 2 + 3, y + 10 + 3));
        FillRect(Rect(x + 10, y + 2, x + 10 + 3, y + 2 + 3));
        if dice[d] = 6 then begin
          FillRect(Rect(x + 2, y + 6, x + 2 + 3, y + 6 + 3));
          FillRect(Rect(x + 10, y + 6, x + 10 + 3, y + 6 + 3));
        end;
      end;
    end;
  end;
end;


procedure TFrame2.Label4Click(Sender: TObject);
begin
  Help('Caracteristiques.rtf');
end;

procedure TFrame2.SpeedButton1Click(Sender: TObject);
var
  c: TAbility;
begin
  with TSpeedButton(Sender) do begin
    c := TAbility(Tag);
    if Caption = '+' then begin
  // on ne peut pas augmenter au del de 18
      if DiceRoll[c].Total = 18 then exit;
  // on vrifie que l'on ne restaure pas un score
      if (DiceRoll[c].adjust < 0) then begin
   // il nous faut au moins un point
        if Reserve = 0 then exit;
        dec(Reserve);
      end else begin
   // sinon, a cote 2 points
        if Reserve < 2 then exit;
        dec(Reserve, 2);
      end;
   // ajouter le point
      inc(DiceRoll[c].adjust);
      inc(DiceRoll[c].total);
    end else begin
  // on ne peut pas descendre un score en dessous de 3
      if DiceRoll[c].Total < 4 then exit;
  // on ajoute un point  la rserve
      if DiceRoll[c].adjust > 0 then inc(Reserve);
      dec(DiceRoll[c].Total);
      dec(DiceRoll[c].Adjust);
      inc(Reserve);
    end;
  end;
  case Reserve of
    0: lbReserve.Caption := 'aucun point en rserve';
    1: lbReserve.Caption := '1 point en rserve';
  else lbReserve.Caption := IntToStr(Reserve) + ' points en rserve';
  end;
  pbCaracteristiquesPaint(Self);
end;

procedure TFrame2.pbCaracteristiquesPaint(Sender: TObject);
var
  c: TAbility;
  x, y, dy, i: integer;
  s: string;
begin
  with pbCaracteristiques, Canvas do begin
    Brush.Color := clBlack;
    FillRect(Rect(lbScore.Left - Left, 0, Width, Height));
    Brush.Style := bsClear;
    y := 0;
    dy := Height div 6;
    for c := Low(TAbility) to High(TAbility) do begin
      Font.Color := clWhite;
      TextOut(0, y, AbilityNames[c]); // nom de la caractrisque
      x := lbTirage.Left - Left - 8;
      for i := 0 to 3 do begin
        DessinerDe(Canvas, x, y, c, i);
        inc(x, 16);
      end;
      s := IntToStr(DiceRoll[c].total);
      Brush.Style := bsClear;
      if DiceRoll[c].adjust < 0 then Font.Color := clRed else
        if DiceRoll[c].adjust > 0 then Font.Color := clBlue else Font.Color := clWhite;
      TextOut(lbScore.Left - Left + (lbScore.Width - TextWidth(s)) div 2, y, s);
      inc(y, dy);
    end;
  end;
end;

end.
